NXOpen .NET Reference Guide  1899
 All Classes Namespaces Functions Variables Enumerations Enumerator Properties
Public Types | Public Member Functions | Properties | List of all members
NXOpen.Preferences.PartObject Class Reference

Represents the set of object preferences applicable to entire part. More...

Inheritance diagram for NXOpen.Preferences.PartObject:
NXOpen.Utilities.NXRemotableObject IMessageSink

Public Types

enum  ColorSelection { NoChange, DefaultColor, Color }
 Describes whether color of object is not changed or it is default color or it is defined by user More...
 
enum  LineFontType {
  PartDefault = 1, Solid, Dashed, Phantom,
  Centerline, Dotted, LongDashed, DottedDashed,
  Eight, Nine, Ten, Eleven
}
 Represents the available types for font More...
 
enum  ObjectType {
  General, Line, Arc, Conic,
  Spline, Solidbody, Sheetbody, Datum,
  Point, CoordinateSystem, AllButDefault, DatumCsys,
  Traceline, InfiniteLine, PointCloud
}
 Describes all available Types for object selection More...
 
enum  WidthType {
  PartDefault = 1, ThinWidth, NormalWidth, ThickWidth,
  WidthOne, WidthTwo, WidthThree, WidthFour,
  WidthFive, WidthSix, WidthSeven, WidthEight,
  WidthNine
}
 Describes the available types for width More...
 

Public Member Functions

unsafe
NXOpen.Preferences.ViewVisualizationSpecialEffects.ColorRGB 
ConvertColorNumberToRGBValue (int colorNumber)
 Converts color number to RGB constituents. More...
 
unsafe int ConvertRGBValueToColorNumber (NXOpen.Preferences.ViewVisualizationSpecialEffects.ColorRGB fogColorRgbValue)
 Converts RGB color constituents to color number. More...
 
unsafe int GetColor (NXOpen.Preferences.PartObject.ObjectType type)
 Returns the current color value for specified type. More...
 
unsafe void GetLegacyLineWidthMap (out NXOpen.Preferences.PartObject.WidthType[] newLineWidths)
 Gets line width map that is used to convert legacy line widths to new line widths. More...
 
unsafe
NXOpen.Preferences.PartObject.LineFontType 
GetLineFont (NXOpen.Preferences.PartObject.ObjectType type)
 Returns the current line font for specified object type More...
 
unsafe
NXOpen.Preferences.PartObject.WidthType 
GetWidth (NXOpen.Preferences.PartObject.ObjectType type)
 Returns the current width for specified object type More...
 
unsafe bool MigrateLegacyLineWidths ()
 Migrates line width attributes stored in the part file to corresponding new line widths. More...
 
unsafe void SetColor (NXOpen.Preferences.PartObject.ObjectType type, int color)
 Sets the color. More...
 
unsafe void SetLegacyLineWidthMap (NXOpen.Preferences.PartObject.WidthType[] newLineWidths)
 Sets line width map that is used to convert legacy line widths to new line widths. More...
 
unsafe void SetLineFont (NXOpen.Preferences.PartObject.ObjectType type, NXOpen.Preferences.PartObject.LineFontType lineFont)
 Sets line font for specified object type More...
 
unsafe void SetWidth (NXOpen.Preferences.PartObject.ObjectType type, NXOpen.Preferences.PartObject.WidthType width)
 Sets width for specified object type More...
 
- Public Member Functions inherited from NXOpen.Utilities.NXRemotableObject
IMessageCtrl AsyncProcessMessage (IMessage msg, IMessageSink replySink)
 Asynchronously processes the given message. More...
 
IMessage SyncProcessMessage (IMessage msg)
 Synchronously processes the given message. More...
 

Properties

unsafe bool FaceAnalysis [get, set]
 Returns or sets the face analysis flag for Solid and Sheets More...
 
unsafe bool PartiallyShaded [get, set]
 Returns or sets the partially shaded flag for Solid and Sheets More...
 
unsafe int PointSymbol [get, set]
 Returns or sets the point symbol for Point More...
 
Tag Tag [get]
 Returns the tag of this object. More...
 
unsafe int Translucency [get, set]
 Returns or sets the translucency value More...
 
- Properties inherited from NXOpen.Utilities.NXRemotableObject
IMessageSink NextSink [get]
 Gets the next message sink in the sink chain. More...
 

Additional Inherited Members

- Protected Member Functions inherited from NXOpen.Utilities.NXRemotableObject
void initialize ()
 <exclude> More...
 

Detailed Description

Represents the set of object preferences applicable to entire part.

All the preferences available at UG GUI for object can be set by using this class except work layer. Work Layer should be set by using NXOpen.Layer.LayerManager class which holds a work layer property.

To obtain an instance of this class, refer to NXOpen.Preferences.PartPreferences

Created in NX3.0.0

Member Enumeration Documentation

Describes whether color of object is not changed or it is default color or it is defined by user

Enumerator
NoChange 

No Change

DefaultColor 

Default Color

Color 

User Defined Color

Represents the available types for font

Enumerator
PartDefault 

Default Value from Part

Solid 

Solid

Dashed 

Dashed

Phantom 

Phantom

Centerline 

Centerline

Dotted 

Dotted

LongDashed 

Long Dashed

DottedDashed 

Dotted Dashed

Eight 

Long Dashed Double Dotted

Nine 

Long Dashed Dotted for OOTB fonts and Undulating for shipbuilding fonts

Ten 

Long Dashed Triplicate Dotted for OOTB fonts and Zigzag for shipbuilding fonts

Eleven 

Long Dashed Double Short Dashed for OOTB fonts and Railway for shipbuilding fonts

Describes all available Types for object selection

Enumerator
General 

Default Type Value

Line 

Line

Arc 

Arc

Conic 

Conic

Spline 

Spline

Solidbody 

Solid Body

Sheetbody 

Sheet Body

Datum 

Datum

Point 

Point

CoordinateSystem 

Coordinate System

AllButDefault 

All But Default

DatumCsys 

Datum CSYS Feature

Traceline 

Traceline

InfiniteLine 

Infinite Line

PointCloud 

Point Cloud

Describes the available types for width

Enumerator
PartDefault 

Default Value from Part

ThinWidth 

Thin Width

NormalWidth 

Normal Width

ThickWidth 

Thick Width

WidthOne 
WidthTwo 
WidthThree 
WidthFour 
WidthFive 
WidthSix 
WidthSeven 
WidthEight 
WidthNine 

Member Function Documentation

unsafe NXOpen.Preferences.ViewVisualizationSpecialEffects.ColorRGB NXOpen.Preferences.PartObject.ConvertColorNumberToRGBValue ( int  colorNumber)
inline

Converts color number to RGB constituents.

The color number passed should be between 1 to 216

Created in NX3.0.0

License requirements: None.

Parameters
colorNumberColor value
Returns
Equivalent RGB constituents
unsafe int NXOpen.Preferences.PartObject.ConvertRGBValueToColorNumber ( NXOpen.Preferences.ViewVisualizationSpecialEffects.ColorRGB  fogColorRgbValue)
inline

Converts RGB color constituents to color number.

The Red, Green and Blue color constituents should be between 0 to 255.

Created in NX3.0.0

License requirements: None.

Parameters
fogColorRgbValue
Returns
Equivalent color value
unsafe int NXOpen.Preferences.PartObject.GetColor ( NXOpen.Preferences.PartObject.ObjectType  type)
inline

Returns the current color value for specified type.

The equivalent RGB values can be found by calling ConvertColorNumberToRGBValue

Red Component is ((((216 - color_number) % 36)/6)* 51) Green component is (((216 - color_number)/36) * 51) Blue is (((216 - color_number) % 6)* 51). So for example if returned color value is 47 then Red is ((((216 - 47) % 36)/6)* 51) = (((169 % 36)/6)* 51) = ((25/6)* 51) = 4*51 = 204 Green is (((216 - 47)/36) * 51) = ((169/36) * 51) = 4*51 = 204 Blue is (((216 - 47) % 6)* 51) = ((169 % 6)* 51) = 1*51 = 51

Created in NX3.0.0

License requirements: None.

Parameters
type
Returns
unsafe void NXOpen.Preferences.PartObject.GetLegacyLineWidthMap ( out NXOpen.Preferences.PartObject.WidthType[]  newLineWidths)
inline

Gets line width map that is used to convert legacy line widths to new line widths.

Following widths are considered as legacy line widths. Preferences.PartObject.WidthType.ThinWidth Preferences.PartObject.WidthType.NormalWidth Preferences.PartObject.WidthType.ThickWidth

New line widths contain corresponding line widths for above three legacy line widths respectively. New line widths start at Preferences.PartObject.WidthType.WidthOne .

Created in NX10.0.0

License requirements: None.

Parameters
newLineWidthsArray of 3 new widths each corresponding to a legacy width. First element corresponds to Thin width Second element corresponds to Normal width Third element corresponds to Thick width.
unsafe NXOpen.Preferences.PartObject.LineFontType NXOpen.Preferences.PartObject.GetLineFont ( NXOpen.Preferences.PartObject.ObjectType  type)
inline

Returns the current line font for specified object type

Created in NX3.0.0

License requirements: None.

Parameters
type
Returns
unsafe NXOpen.Preferences.PartObject.WidthType NXOpen.Preferences.PartObject.GetWidth ( NXOpen.Preferences.PartObject.ObjectType  type)
inline

Returns the current width for specified object type

Created in NX3.0.0

License requirements: None.

Parameters
type
Returns
unsafe bool NXOpen.Preferences.PartObject.MigrateLegacyLineWidths ( )
inline

Migrates line width attributes stored in the part file to corresponding new line widths.

The migration is performed based on the legacy line width map stored in the part file.

See Preferences.PartObject.GetLegacyLineWidthMap

Line widths of various displayable objects such as solids, wireframe, drawing views etc. will be updated to new line widths. Display is regenerated if necessary to reflect the changes. A displayable object, that already has new line width assigned to it, is not affected.

Created in NX10.0.0

License requirements: None.

Returns
At least one legacy line width attribute has been migrated.
unsafe void NXOpen.Preferences.PartObject.SetColor ( NXOpen.Preferences.PartObject.ObjectType  type,
int  color 
)
inline

Sets the color.

For Default color pass -2 as color value and for no change pass -1. For other color calculate the color in RGB format. If you pass R value of Red component G value of Green and B value of Blue the color will be: color = (((255-R)/51)*6 + ((255-G)/51)*36 + ((255-B)/51)*1) + 1 ; Where R G and B values are between 0 and 255 . So for Green (0,255,0)we will pass color = (((255-0)/51)*6 + ((255-255)/51)*36 + ((255-0)/51)*1) + 1 = 30+0+5+1 = 36 The equivalent color number value can be found by calling ConvertRGBValueToColorNumber

Created in NX3.0.0

License requirements: None.

Parameters
type
colorSpecified Color
unsafe void NXOpen.Preferences.PartObject.SetLegacyLineWidthMap ( NXOpen.Preferences.PartObject.WidthType[]  newLineWidths)
inline

Sets line width map that is used to convert legacy line widths to new line widths.

See Preferences.PartObject.GetLegacyLineWidthMap

The new line widths used to map legacy line width are in logical order; i.e.; Preferences.PartObject.WidthType.ThinWidth maps to a smaller width value compared to Preferences.PartObject.WidthType.NormalWidth and so on. Otherwise, the legacy line width map will be rejected.

Created in NX10.0.0

License requirements: None.

Parameters
newLineWidthsArray of 3 new widths each corresponding to a legacy width. First element corresponds to Thin width Second element corresponds to Normal width Third element corresponds to Thick width.
unsafe void NXOpen.Preferences.PartObject.SetLineFont ( NXOpen.Preferences.PartObject.ObjectType  type,
NXOpen.Preferences.PartObject.LineFontType  lineFont 
)
inline

Sets line font for specified object type

Created in NX3.0.0

License requirements: None.

Parameters
type
lineFont
unsafe void NXOpen.Preferences.PartObject.SetWidth ( NXOpen.Preferences.PartObject.ObjectType  type,
NXOpen.Preferences.PartObject.WidthType  width 
)
inline

Sets width for specified object type

Created in NX3.0.0

License requirements: None.

Parameters
type
width

Property Documentation

unsafe bool NXOpen.Preferences.PartObject.FaceAnalysis
getset

Returns or sets the face analysis flag for Solid and Sheets

Created in NX3.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe bool NXOpen.Preferences.PartObject.PartiallyShaded
getset

Returns or sets the partially shaded flag for Solid and Sheets

Created in NX3.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe int NXOpen.Preferences.PartObject.PointSymbol
getset

Returns or sets the point symbol for Point

Created in NX1872.0.0

License requirements to get this property: None.

License requirements to set this property: None.

Tag NXOpen.Preferences.PartObject.Tag
get

Returns the tag of this object.

unsafe int NXOpen.Preferences.PartObject.Translucency
getset

Returns or sets the translucency value

Created in NX3.0.0

License requirements to get this property: None.

License requirements to set this property: None.


The documentation for this class was generated from the following file:
Copyright 2019 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.